=== debian/changelog ===
astroidmail (0.17+ds-3) unstable; urgency=medium

  * autopkgtest-depend on xvfb;
    closes: bug#1127591, thanks to Adrian Bunk
  * stop superfluously set fields Rules-Requires-Root Priority
  * declare compliance with Debian Policy 4.7.3

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 22 Feb 2026 13:02:01 +0100

astroidmail (0.17+ds-2) unstable; urgency=medium

  * acknowledge NMU;
    thanks to Alexandre Detiste

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 09 Feb 2026 11:46:11 +0100

astroidmail (0.17+ds-1) unstable; urgency=medium

  [ upstream ]
  * new release;
    notable changes since previous development snapshot:
    + tvextension: Fix protobuf 30.0 compatibility issue

  [ Jonas Smedegaard ]
  * add metadata about upstream project
  * update git-buildpackage config: improve usage comment
  * update watch file:
    + mangle filename
    + use Github API
    + track release tags (not git commits)
  * declare compliance with Debian Policy 4.7.2
  * update copyright info:
    + update coverage
    + license patches same as main upstream license
  * stop superfluously autopkgtest-depend on xvfb xauth
  * add patch cherry-picked upstream to stop use boost-system;
    closes: bug#1127169, thanks to Matthias Klose
  * add patch cherry-picked upstream to support newer CMake
  * stop build-depend on libgirepository1.0-dev;
    stop cleanup unused GI object files;
    closes: bug#1118786, thanks to Simon McVittie

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 09 Feb 2026 11:25:22 +0100

astroidmail (0.16+20240629-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove obsolete debian/README.source

 -- Alexandre Detiste <tchet@debian.org>  Sun, 17 Aug 2025 20:20:56 +0200
